let expand _ s = match s with
  | "small_sleep" ->
     (match Sys.os_type with
        | "Win32" | "Cygwin" -> "fun () -> Unix.sleep 1"
        | "Unix" -> "
            let mysleep n = (* see the caml list, message 2000-11-10 (18:42) *)
              let start = Unix.gettimeofday() in
              let rec delay t =
                try
                  ignore (Unix.select [] [] [] t)
                with Unix.Unix_error(Unix.EINTR, _, _) ->
                  let now = Unix.gettimeofday() in
                  let remaining = start +. n -. now in
                  if remaining > 0.0 then delay remaining in
              delay n
            in fun () -> mysleep 0.1"
        | _ -> failwith "New os_type in Sys.os_type, wasn't documented in OCaml 3.08")
  | _ -> failwith "undefined";;

Quotation.add "foo" (Quotation.ExStr expand);;
Quotation.default := "foo";;
